dot/e16-bindings: Make 5-F6 toggle keyboard mouse control.
[profile] / setup
1 #! /bin/bash
2
3 set -e
4
5 ###--------------------------------------------------------------------------
6 ### Basic setup.
7
8 umask 002
9
10 sub=
11 mkdir -p $HOME$sub
12
13 : ${REPO=http://ftp.distorted.org.uk/ftp/pub/mdw/profile}
14
15 export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
17 ###--------------------------------------------------------------------------
18 ### Sort out command line.
19
20 xstuff= false=
21 while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30 done
31
32 ###--------------------------------------------------------------------------
33 ### Environment autoconfiguration.
34
35 ## Find out where I am
36 here=$(pwd)
37
38 ## Suss out how to print things
39 out=$(echo -n "foo"; echo "bar")
40 if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43 else
44 echon="echo"
45 echoc='\c'
46 fi
47
48 ## Find out how to fetch things over the net
49 $echon "Finding URL fetcher:$echoc"
50 if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53 elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56 else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60 fi
61
62 ###--------------------------------------------------------------------------
63 ### Create the necessary directories.
64
65 echo "Creating directories..."
66 for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74 done
75 echo " all done."
76
77 ###--------------------------------------------------------------------------
78 ### Install some more complicated programs.
79
80 echo "Installing packages..."
81 systems="
82 mlib:crc-mktab
83 checkpath:tmpdir
84 "
85 [ "$xstuff" ] && systems="$systems
86 xtoys:xatom
87 "
88 for system in $systems; do
89 set -- $(echo $system | tr : ' ')
90 sys=$1 prog=$2
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
100 $echon " unpacking$echoc"
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
103 $echon " configuring$echoc"
104 cd $dir
105 mkdir build
106 cd build
107 ../configure --prefix=$HOME$sub >>buildlog 2>&1
108 $echon " building$echoc"
109 make >>buildlog 2>&1
110 $echon " installing$echoc"
111 make install >>buildlog 2>&1
112 echo " done."
113 )
114 fi
115 done
116 echo " all done."
117
118 ###--------------------------------------------------------------------------
119 ### Install global configuration.
120
121 echo -n "Installing dotfile configuration:"
122 if [ -f $HOME$sub/.mdw.conf ]; then
123 echo " already installed."
124 else
125 cp mdw.conf $HOME$sub/.mdw.conf
126 echo " done."
127 fi
128
129 ## Symlink the various dotfiles into place
130 dotfiles="
131 bash_profile bash_logout bashrc inputrc bash_completion
132 emacs emacs-calc vm gnus.el
133 vimrc mg zile
134 mailrc signature
135 cgrc tigrc
136 gdbinit
137 guile
138 toprc
139 aspell.conf
140 lisp-init.lisp:.cmucl-init.lisp
141 lisp-init.lisp:.sbclrc
142 lisp-init.lisp:.clisprc.lisp
143 lisp-init.lisp:.eclrc
144 swank.lisp
145 dircolors colordiffrc screenrc cvsrc indent.pro"
146 [ "$xstuff" ] && dotfiles="$dotfiles
147 xinitrc xsession Xdefaults vncrc vncsession
148 fonts.conf
149 stalonetrayrc
150 putty-defaults:.putty/sessions/Default%20Settings
151 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
152 e-keybindings.cfg:.enlightenment/keybindings.cfg
153 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
154 e16-bindings:.e16/bindings.cfg"
155 echo "Installing dotfiles..."
156 for d in $dotfiles; do
157 target=.$d
158 case $d in
159 *:*) target=${d#*:} d=${d%%:*};;
160 esac
161 ft=$HOME$sub/$target
162 dir=${ft%/*}
163 mkdir -p $dir
164 ln -s $here/dot/$d $ft.new
165 mv $ft.new $ft
166 echo " $target"
167 done
168 echo " all done."
169
170 ## Symlink backgrounds.
171 backgrounds="
172 jue-peek.jpg
173 medusa.jpg
174 rayne.jpg
175 hypatia.jpg
176 noodly.jpg"
177 if [ "$xstuff" ]; then
178 echo "Installing backgrounds..."
179 for b in $backgrounds; do
180 for e in enlightenment e16; do
181 dir=$HOME$sub/.$e/backgrounds
182 t=$dir/$b
183 mkdir -p $dir
184 ln -s $here/bg/$b $t.new
185 mv $t.new $t
186 done
187 echo " $b"
188 done
189 echo " all done."
190 fi
191
192 ###--------------------------------------------------------------------------
193 ### Process the Git configuration.
194
195 echo -n "Installing Git configuration:"
196 sed "
197 1i\
198 ### generated by $here/setup; do not edit!\
199
200 /@releasekey@/ s::$(bin/mdw-conf release-key 481334C2):g
201 /@gitignore@/ s::$(bin/mdw-conf gitignore $here/git/gitignore):g
202 " git/gitconfig >$HOME/.gitconfig.new
203 mv $HOME/.gitconfig.new $HOME/.gitconfig
204 echo " done."
205
206 ###--------------------------------------------------------------------------
207 ### Install useful scripts included in this package.
208
209 scripts="
210 mdw-editor
211 mdw-pager
212 mdw-conf
213 mdw-build
214 movemail-hack
215 emerge-hack
216 lesspipe.sh
217 start-ssh-agent
218 svnwrap
219 hyperspec"
220 [ "$xstuff" ] && scripts="$scripts
221 xinitcmd
222 un-backslashify-selection
223 lock-screen
224 xshutdown"
225 echo "Installing scripts..."
226 mkdir -p $HOME$sub/bin
227 for s in $scripts; do
228 ft=$HOME$sub/bin/$s
229 ln -s $here/bin/$s $ft.new
230 mv $ft.new $ft
231 echo " $s"
232 done
233 echo " all done."
234
235 ###--------------------------------------------------------------------------
236 ### Set up the Emacs config.
237
238 $echon "Finding a suitable emacs:$echoc"
239 emacs=no
240 for i in emacs22 emacs21 emacs; do
241 if type -p >/dev/null $i; then
242 emacs=$i
243 break
244 fi
245 done
246 if [ $emacs = no ]; then
247 echo " failed."
248 emacs=:
249 else
250 echo " $emacs."
251 fi
252
253 echo "Installing Emacs packages..."
254 emacspkg="
255 make-regexp
256 ew-hols
257 mdw-gnus-patch
258 git git-blame vc-git stgit
259 quilt"
260 for elib in $emacspkg; do
261 $echon " $elib:$echoc"
262 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
263 (progn
264 (setq load-path (nconc load-path (list "~/lib/emacs")))
265 (kill-emacs (condition-case nil
266 (progn (load-library "'"$elib"'") 0)
267 (error 1))))'; then
268 echo " already installed."
269 else
270 if [ -f el/$elib.el ]; then
271 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
272 else
273 $echon " downloading$echoc"
274 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
275 fi
276 $echon " compiling$echoc"
277 (cd $HOME$sub/lib/emacs;
278 $emacs >/dev/null 2>&1 --no-site-file --batch \
279 --eval '(byte-compile-file "'"$elib.el"'")')
280 echo " done."
281 fi
282 done
283 echo " all done."
284
285 $echon "Setting up Emacs configuration:$echoc"
286 $echon " linking$echoc"
287 for f in dot-emacs.el Makefile; do
288 set -- $(echo $link | tr : ' ')
289 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
290 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
291 done
292 $echon " compiling$echoc"
293 make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
294 echo " done."
295
296 ###----- That's all, folks --------------------------------------------------